#include "Loconet.h"
#include "DrawModul.h"

void TrackLine  (int fx, int fy);
void TrackEnviron (int fx, int fy);
void TrackSlant (int fx, int fy, int corner);
void TrackHLine (int fx, int fy, int corner);
void TurnoutPos(int fx, int fy, int corner, int colour);
void TurnoutDir(int fx, int fy, int Turn, int Colour);
void DrawDiagonalStand(int fx, int fy, int SwStand);
void DrawSwitchStand(int fx, int fy, int SwStand);
void TrackArrow (int fx, int fy, int corner);
void DrawSTurnout(int fx, int fy, int corner);
void DrawTurnout(int fx, int fy, int corner);
void TrackEdge(int fx, int fy, byte Edge);
void TrackLight (int fx, int fy, int Colour);
void StandSig (int fx, int fy, int corner);
void StandHSig(int fx, int fy, int corner);
void CircleSig (int fx, int fy, int corner, int colour);
void ShPicture (int fx, int fy, int corner, byte ShZeichen);
void ShHPicture(int fx, int fy, int corner, byte ShZeichen);
void Linie(int x1, int y1, int x2, int y2, int linecol);
void TurnoutLong(int fx, int fy, int corner, int colour);
void SetTxtPtr(uint8_t x, uint8_t y);

int  TouchNotify(void);
extern int  GL_rval;
extern char buf;

extern int GL_pixXmax;
extern int GL_pixYmax;

char TextColourYe[] = {0xFF, 0xEE, 0xFF, 0xE0};
char TextColourWh[] = {0xFF, 0xEE, 0xFF, 0xFF}; // Foreground
char TextColourBl[] = {0xFF, 0xEE, 0x00, 0x00}; // Foreground
char TextBackGrnd[] = {0xFF, 0xED, 0xD6, 0x99}; // OFFGRAY
char TextRCBackGd[] = {0xFF, 0xED, 0xF8, 0x00}; // RED
char TextBackGrndBl[] = {0xFF, 0xED, 0x00, 0x00}; // Black
char TextBackGrndWh[] = {0xFF, 0xED, 0xFF, 0xFF}; // White
char TextBackGrndKH[] = {0xFF, 0xED, 0xFE, 0x68}; // Kaki
char TextBackGrndGN[] = {0xFF, 0xED, 0x07, 0x80}; // Gruen 0x0780

char TextFont[]     = {0xFF, 0xEC, 0x00, 0x01};
char TextCursor[]   = {0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00}; // line, column
char TextHeight[]   = {0xFF, 0xEA, 0x00, 0x02};
char TextOrigin[]   = {0xFF, 0x81, 0x00, 0x00, 0x00, 0x00}; // XposH, XposL, YposH, YposL

char BackGround[]   = {0xFF, 0x48, 0xD6, 0x99};

char ClearScreen[] = {0xFF, 0x82};

char SetPixel[]     = {0xFF, 0x76, 0x00, 100, 0x00, 240, 0xFF, 0xFF}; // XposH, XposL, YposH, YposL, Colour

char DrawRectaF[]   = {0xFF, 0x79, 0x00, 0x00, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
//         X1        Y1        X2        Y2        Colour
char DrawFilCirc[]  = {0xFF, 0x77, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


void SetTxtPtr(uint8_t x, uint8_t y) {

  uint16_t xpos = x * FELDSX + 5;
  uint16_t Ypos = y * FELDSY + (FELDSY / 2 - 5);

  TextOrigin[2] = xpos >> 8; TextOrigin[3] =  xpos & 0x00FF;
  TextOrigin[4] = Ypos >> 8; TextOrigin[5] =  Ypos & 0x00FF;
  Serial2.write(TextOrigin, 6); delayS2();

}


void AnzeigeRC(uint8_t Ma, uint16_t La, byte flg) {
  byte zx = (Ma / 10) | 0x30; Ma = Ma % 10;
  byte ex =  Ma     | 0x30;
  if (zx == '0') zx = ' ';

  byte t = (La / 1000) | 0x30; La = La % 1000;
  byte h = (La / 100) | 0x30; La = La % 100;
  byte z = (La / 10)  | 0x30; La = La % 10;
  byte e =  La      | 0x30;
  if (t == '0')
  { t =  ' ';
    if (h == '0')
    { h =  ' ';
      if (z == '0')
      {
        z =  ' ';
      };
    }
  }
  if (flg) {
    bingo[0] = zx;
    bingo[1] = ex;
    bingo[2] = '-';
    bingo[3] = t;
    bingo[4] = h;
    bingo[5] = z;
    bingo[6] = e;
    bingo[7] = ' ';
    bingo[8] = ' ';
  }
  else     {
    bingo[0] = ' ';
    bingo[1] = '-';
    bingo[2] = ' ';
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
    bingo[7] = ' ';
    bingo[8] = ' ';
  }

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (bingo, 8); Serial2.write (0); delayS2();
} // AnzeigeRC()


void AnzeigeRCLok(uint16_t La, byte flg) {

  byte t = (La / 1000) | 0x30; La = La % 1000;
  byte h = (La / 100) | 0x30; La = La % 100;
  byte z = (La / 10)  | 0x30; La = La % 10;
  byte e =  La      | 0x30;
  if (t == '0')
  { t =  ' ';
    if (h == '0')
    { h =  ' ';
      if (z == '0')
      {
        z =  ' ';
      };
    }
  }
  if (flg) {
    bingo[0] = t;
    bingo[1] = h;
    bingo[2] = z;
    bingo[3] = e;
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
    bingo[7] = ' ';
  }

  else     {
    bingo[0] = ' ';
    bingo[1] = ' ';
    bingo[2] = ' ';
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
    bingo[7] = ' ';
  }

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (bingo, 8); Serial2.write (0); delayS2();
} // AnzeigeRCLok()


void i2str(byte flg, int i) { // nur bis + 999
  byte h = (i / 100) | 0x30; i = i % 100;
  byte z = (i / 10)  | 0x30; i = i % 10;
  byte e =  i      | 0x30;
  if (flg) {
    bingo[0] = h;
    bingo[1] = z;
    bingo[2] = e;
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
  }
  else     {
    bingo[0] = ' ';
    bingo[1] = '-';
    bingo[2] = ' ';
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
  }

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (bingo, 7); Serial2.write (0); delayS2();
} // i2str()


void AnzeigeEle(byte flg, byte Ele) {
  byte NibbH = (Ele >> 4)  | 0x30;  // Wandlung in Hex
  byte NibbL = (Ele & 0x0F) | 0x30;
  if (NibbH > 0x39) NibbH = NibbH + 7;
  if (NibbL > 0x39) NibbL = NibbL + 7;

  if (flg) {
    bingo[0] = 'x';
    bingo[1] = NibbH;
    bingo[2] = NibbL;
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
  }
  else     {
    bingo[0] = ' ';
    bingo[1] = '-';
    bingo[2] = ' ';
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
  }

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (bingo, 7); Serial2.write (0); delayS2();
} // AnzeigeEle()


void AnzeigeXY(byte kx, byte ky, byte flg) {
  byte zx = (kx / 10) | 0x30; kx = kx % 10;
  byte ex =  kx     | 0x30;
  if (zx == '0') zx = ' ';

  byte zy = (ky / 10) | 0x30; ky = ky % 10;
  byte ey =  ky     | 0x30;
  if (zy == '0') zy = ' ';

  if (flg) {
    bingo[0] = zx;
    bingo[1] = ex;
    bingo[2] = '/';
    bingo[3] = zy;
    bingo[4] = ey;
    bingo[5] = ' ';
    bingo[6] = ' ';
  }
  else     {
    bingo[0] = ' ';
    bingo[1] = '-';
    bingo[2] = ' ';
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
  }

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (bingo, 7); Serial2.write (0); delayS2();
} // AnzeigeXY()


void AnzeigeBM(byte bm, byte flg) {
  byte zbm = (bm / 10) | 0x30; bm = bm % 10;
  byte ebm =  bm     | 0x30;
  if (zbm == '0') zbm = ' ';

  if (flg) {
    bingo[0] = 'B';
    bingo[1] = 'M';
    bingo[2] = ' ';
    bingo[3] = zbm;
    bingo[4] = ebm;
    bingo[5] = ' ';
    bingo[6] = ' ';
  }
  else     {
    bingo[0] = ' ';
    bingo[1] = '-';
    bingo[2] = ' ';
    bingo[3] = ' ';
    bingo[4] = ' ';
    bingo[5] = ' ';
    bingo[6] = ' ';
  }

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (bingo, 7); Serial2.write (0); delayS2();
} // AnzeigeBM()


void DrawPanel(int fx, int fy, int appear) {
  char Draw_Panel[]   = {0xFF, 0x5F, 0x00, 0x00, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10, 0x00, 0x00};
  //         State     X         Y         With      Height    Colour

  int X = fx * FELDSX + 10; int Y = fy * FELDSY + 5;
  Draw_Panel[3] = lowByte(appear);
  Draw_Panel[4] = X >> 8; Draw_Panel[5] = X & 0x00FF;
  Draw_Panel[6] = Y >> 8; Draw_Panel[7] = Y & 0x00FF;
  Draw_Panel[8] = 0; Draw_Panel[9] = 40;
  Draw_Panel[10] = 0; Draw_Panel[11] = 30;

  Draw_Panel[12] = SILGRAY >> 8; Draw_Panel[13] = SILGRAY & 0x00FF;
  Serial2.write (Draw_Panel, 14); delayS2();
} // DrawPanel()


void  TextPanel(int fx, int fy, char* ptxt) {

  // Textposition -> TextPanel(),komischer Effekt, Xpos, Ypos Compiler Fehler

  int Xpo = (fx * FELDSX) + 18; int Ypo = (fy * FELDSY) + 15;
  TextOrigin[2] = Xpo >> 8; TextOrigin[3] =  Xpo & 0x00FF;
  TextOrigin[4] = Ypo >> 8; TextOrigin[5] =  Ypo & 0x00FF;
  Serial2.write(TextOrigin, 6); delayS2();

  strcpy(bingo, "   ");             // Text kann aus 0,1,2 und >3 Zeichen bestehen
  if (ptxt[0]) {
    bingo[0] = ptxt[0];  // Text auf Taste
    if (ptxt[1]) {
      bingo[1] = ptxt[1];
      if (ptxt[2]) bingo[2] = ptxt[2];
    };
  };

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (bingo, 3); Serial2.write (0); delayS2();
} // TextPanel()


void  SigName (int fx, int fy, char* ptxt) {

  int KorX = 0;
  int KorY = 0;

  byte Signal  = StpS[fy][fx];
  switch (Signal & 0x1F) {
    case 26:
      KorX = 15; KorY = 26;
      break;
    case 27:
      KorX = 30; KorY =  3;
      break;
    case 28:
    case 30:
      KorX = 20; KorY = 26;
      break;
    case 29:
    case 31:
      KorX = 30; KorY =  3;
      break;
    default:
      break;
  }
  int Xpo = (fx * FELDSX) + KorX; int Ypo = (fy * FELDSY) + KorY;
  TextOrigin[2] = Xpo >> 8; TextOrigin[3] =  Xpo & 0x00FF;
  TextOrigin[4] = Ypo >> 8; TextOrigin[5] =  Ypo & 0x00FF;
  Serial2.write(TextOrigin, 6); delayS2();

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (ptxt, strlen(ptxt)); Serial2.write (0); delayS2();
} // SigName()



void  TextInfoPos(int fx, int fy, char* ptxt, byte poskorr, byte option) {
  // Positionskorrektur, Hintergrund individuell (option)

  byte Element = StpM[fy][fx];  // falls erforderlich
  int KorX = 18; // default
  int KorY = 15;

  int slen = strlen(ptxt);

  switch (poskorr) {
    case 1: KorY = 2;             // t, Textinfo
      break;
    case 2: KorX = 30; KorY = 5;  // i, Meldebox, Text oben
      break;
    case 3: KorX = 30; KorY = 22; // i, Meldebox, Text unten
      break;
    case 4: KorX = 25; KorY = 25; // K, Schalttasten
      KorX = KorX - ((slen - 1) * 4); // slen=2->21, slen=7->1
      if (KorX <= 0) KorX = 1;
      break;
    case 5: KorX = 5; KorY = 27;
      break;
    case 0:
    default:
      break;
  }
  int Xpo = (fx * FELDSX) + KorX; int Ypo = (fy * FELDSY) + KorY;
  TextOrigin[2] = Xpo >> 8; TextOrigin[3] =  Xpo & 0x00FF;
  TextOrigin[4] = Ypo >> 8; TextOrigin[5] =  Ypo & 0x00FF;
  Serial2.write(TextOrigin, 6); delayS2();

  switch (option) {   // Hintergrund fuer Text anpassen
    case 1: Serial2.write(TextBackGrndWh, 4); delayS2();   // WHITE
      Serial2.write (0x00);    Serial2.write (0x18);
      Serial2.write (ptxt, slen); Serial2.write (0); delayS2();
      Serial2.write(TextBackGrnd, 4); delayS2();      // typ. Wert
      break;
    case 2:
    case 3: Serial2.write(TextBackGrndKH, 4); delayS2();   // KAKI
      Serial2.write (0x00);    Serial2.write (0x18);
      Serial2.write (ptxt, slen); Serial2.write (0); delayS2();
      Serial2.write(TextBackGrnd, 4); delayS2();      // typ. Wert
      break;
    case 4: Serial2.write(TextBackGrndGN, 4); delayS2();   // Fstr. gruen
      Serial2.write (0x00);    Serial2.write (0x18);
      Serial2.write (ptxt, slen); Serial2.write (0); delayS2();
      Serial2.write(TextBackGrnd, 4); delayS2();      // typ. Wert
      break;
    case 0:
    default:   // Hintergrund ist Standard-Grau
      Serial2.write (0x00);    Serial2.write (0x18);
      Serial2.write (ptxt, slen); Serial2.write (0); delayS2();
      break;
  }
} // TextInfoPos()



void  TextInfo(int fx, int fy, char* ptxt) {
  // Positionskorrektur nach Gleiselement
  byte Element = StpM[fy][fx];
  int KorX = 18; // default
  int KorY = 15;

  switch (Element) {
    case   0: if (fy != 6) KorY = 27; // Schrift unten, auuser untere Zeile
      break;
    case   1:
    case   2:
    case   3: KorY = 0; KorX = 30;
      break;
    case  24:
    case   8: KorX = 40; KorY = 2;  // oben rechts
      break;
    case   9: KorX = 40; KorY = 26; // unten rechts
      break;
    case  10: KorX = 4;  KorY = 26; // unten links
      break;
    case  25:
    case  11: KorX = 4;  KorY = 2;  // oben links
      break;

    case  16:
    case  19: KorY =  2; // Schrift oben
      break;
    case  17:
    case  18: KorY =  27; // Schrift unten
      break;
    default:
      break;
  } // switch

  int Xpo = (fx * FELDSX) + KorX; int Ypo = (fy * FELDSY) + KorY;
  TextOrigin[2] = Xpo >> 8; TextOrigin[3] =  Xpo & 0x00FF;
  TextOrigin[4] = Ypo >> 8; TextOrigin[5] =  Ypo & 0x00FF;
  Serial2.write(TextOrigin, 6); delayS2();

  Serial2.write (0x00);    Serial2.write (0x18);
  Serial2.write (ptxt, strlen(ptxt)); Serial2.write (0); delayS2();
} // TextInfo()


void TouchFieldAll(void) {
  char TouchRegion[]  = {0xFE, 0x6A, 0x00, 0x00, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80};
  //         X1        Y1        X2        Y2

  int x1 = 0;    int y1 = 0;
  int x2 = GL_pixXmax; int y2 = GL_pixYmax;

  TouchRegion[2] = x1 >> 8; TouchRegion[3] =  x1 & 0x00FF;
  TouchRegion[4] = y1 >> 8; TouchRegion[5] =  y1 & 0x00FF;
  TouchRegion[6] = x2 >> 8; TouchRegion[7] =  x2 & 0x00FF;
  TouchRegion[8] = y2 >> 8; TouchRegion[9] =  y2 & 0x00FF;
  Serial2.write (TouchRegion, 10); delayS2();
} // TouchFieldAll()


void TouchSet (int mode) {
  char ts[] = {0xFE, 0x69, 0x00, mode & 0x00FF};
  Serial2.write (ts, 4); delayS2();
} // TouchSet()


void TouchGet (int mode) {
  char tg[] = {0xFE, 0x68, 0x00, mode & 0x00FF};
  Serial2.write (tg, 4); TouchNotify();
} // TouchGet()


int TouchNotify(void) {                        // Rueckmeldung vom Display
  int bytecnt   =  0;
  int retval[5] = {0};
  int i         =  0;

  delay(20); // delay for Display answer

  bytecnt =  Serial2.available();           // Anzahl Bytes vom Display
  if (bytecnt > 0) {
    retval[0] = bytecnt; i++;
    for (bytecnt; bytecnt > 0; bytecnt--) { // Anzahl abholen
      retval[i] = Serial2.read(); i++;
    } // for
  } // if
  for (i = 1; i <= retval[0] ; i++) {
    if (i == 3) GL_rval = (retval[2] << 8) + retval[i];
  } // for
  return GL_rval;
} // TouchNotify()


void delayS2(void) { // Auswertung Rückkanal vom Display (0x06: Kommando bearbeitet)
  // wenn buf = 0x06 dann Buf = 0 und return
  //                 else wait
  do {
    buf = Serial2.read ();
  }
  while (buf != 0x06); // wenn wahr, dann Wiederholung
} // delayS2()



void FeldFarbe(byte fx, byte fy, int colour) {

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1 = -FELDSX / 2 + 3;  int py1 = -FELDSY / 2 + 3;
  int px2 =  FELDSX / 2 - 3;  int py2 =  FELDSY / 2 - 3;

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = colour  >> 8; DrawRectaF[11] = colour  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // Feldfarbe()


void FeldFarbe2(byte fx, byte fy, int colour) {  // fuer Logo

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1 = -FELDSX / 2 + 3;  int py1 = -FELDSY / 2;
  int px2 =  FELDSX / 2 - 3;  int py2 =  FELDSY / 2 - 1;

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = colour  >> 8; DrawRectaF[11] = colour  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // Feldfarbe2()



void CircleF (int fx, int fy, int rad, int colour) {
  int CenterX = 0;
  int CenterY = 0;
  CenterX = fx * FELDSX + (FELDSX / 2);
  CenterY = fy * FELDSY + (FELDSY / 2);
  DrawFilCirc[2] = CenterX >> 8; DrawFilCirc[3] = CenterX & 0x00FF;
  DrawFilCirc[4] = CenterY >> 8; DrawFilCirc[5] = CenterY & 0x00FF;
  DrawFilCirc[6] = rad     >> 8; DrawFilCirc[7] = rad     & 0x00FF;
  DrawFilCirc[8] = colour  >> 8; DrawFilCirc[9] = colour  & 0x00FF;
  Serial2.write (DrawFilCirc, 10); delayS2();
} // CircleF ()


void CircleFB (int fx, int fy, int rad, int colour) {
  int CenterX = 0;
  int CenterY = 0;
  CenterX = fx * FELDSX + (FELDSX / 2) - 12;
  CenterY = fy * FELDSY + (FELDSY / 2) - 12;
  DrawFilCirc[2] = CenterX >> 8; DrawFilCirc[3] = CenterX & 0x00FF;
  DrawFilCirc[4] = CenterY >> 8; DrawFilCirc[5] = CenterY & 0x00FF;
  DrawFilCirc[6] = rad     >> 8; DrawFilCirc[7] = rad     & 0x00FF;
  DrawFilCirc[8] = colour  >> 8; DrawFilCirc[9] = colour  & 0x00FF;
  Serial2.write (DrawFilCirc, 10); delayS2();
} // CircleFB ()


void DrawKey(int fx, int fy, uint8_t butt, int tcolor, char *sptr) {

  int     EckeX = fx * FELDSX + 8;    // 11
  int     EckeY = fy * FELDSY + 3;    //  1
  uint8_t slen  = strlen(sptr);

  // cmd state  x      y     b.col  t.col    font  t.wid
  //0  1   2 3 4  5   6  7   8  9   10   11  12 13 14
  uint8_t db[] = {0, 0x11, 0, 0, 0, 0x50, 0, 0x50, 7, 0xFF, 0x90, 0x1A, 0, 1, 0, // p.56
                  1, 0, 1, 0x50, 0x72, 0x65, 0x73, 0x73, 0x20, 0x4D, 0x65, 0
                 };
  //  t.he String[18]        full Len: 27
  db[ 3] = butt;
  db[ 4] = EckeX >> 8; db[5] = EckeX & 0x00FF;
  db[ 6] = EckeY >> 8; db[7] = EckeY & 0x00FF;
  db[ 8] = 0xD6; // Button color
  db[ 9] = 0x99; // OFFGREY
  db[10] = tcolor >> 8; db[11] = tcolor & 0x00FF;  // Text color
  db[13] = 7 ;   // Text font
  strcpy(db + 18, sptr);
  Serial2.write (db, 18 + slen + 1); delayS2();
} // DrawKey()


// Hilfsausgabe unten
void Text_CR(int xpos) {
  uint16_t Ypos = 0;

  // 6x40+2 = 242; 11x40+2 = 442
  if (GL_ymax > 6) Ypos = 11 * FELDSY + 2;
  else             Ypos =  6 * FELDSY + 2;

  TextOrigin[2] = xpos >> 8; TextOrigin[3] =  xpos & 0x00FF;
  TextOrigin[4] = Ypos >> 8; TextOrigin[5] =  Ypos & 0x00FF;
  Serial2.write(TextOrigin, 6); delayS2();
} // Text_CR()


#define DETECTSET  0x80   // doppelt deklariert !!


void CircleSigShH (int fx, int fy, int corner, int colour) {
  int posX =  9; //19
  int posY = 12;
  int rad  = 4;

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: posX = -posX;
      posY = -posY;
      break;
    default: break;
  }
  int CenterX = fx * FELDSX + (FELDSX / 2) + posX;
  int CenterY = fy * FELDSY + (FELDSY / 2) + posY;
  DrawFilCirc[2] = CenterX >> 8; DrawFilCirc[3] = CenterX & 0x00FF;
  DrawFilCirc[4] = CenterY >> 8; DrawFilCirc[5] = CenterY & 0x00FF;
  DrawFilCirc[6] = rad     >> 8; DrawFilCirc[7] = rad     & 0x00FF;
  DrawFilCirc[8] = colour  >> 8; DrawFilCirc[9] = colour  & 0x00FF;
  Serial2.write (DrawFilCirc, 10); delayS2();
} // CircleSigShH()



void CircleSig (int fx, int fy, int corner, int colour) {
  int posX = 19;
  int posY = 12;
  int rad  = 4;

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: posX = -posX;
      posY = -posY;
      break;
    default: break;
  }
  int CenterX = fx * FELDSX + (FELDSX / 2) + posX;
  int CenterY = fy * FELDSY + (FELDSY / 2) + posY;
  DrawFilCirc[2] = CenterX >> 8; DrawFilCirc[3] = CenterX & 0x00FF;
  DrawFilCirc[4] = CenterY >> 8; DrawFilCirc[5] = CenterY & 0x00FF;
  DrawFilCirc[6] = rad     >> 8; DrawFilCirc[7] = rad     & 0x00FF;
  DrawFilCirc[8] = colour  >> 8; DrawFilCirc[9] = colour  & 0x00FF;
  Serial2.write (DrawFilCirc, 10); delayS2();
} // CircleSig()




void SigScreen (int fx, int fy, int corner) { // Signalschirm
  char DrawTrArrow[40] = {0x00, 0x14, 0x00, 0x05, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
  //         Lenght 5  X1        Y1        ...                      Colour

  int px1 = 12;   int py1 = 6;
  int px2 = 23;   int py2 = 6;
  int px3 = 27;   int py3 = 10;
  int px4 = 27;   int py4 = 14;
  int px5 = 23;   int py5 = 18;
  int px6 = 12;   int py6 = 18;

  int EckX = (fx * FELDSX) + FELDSX / 2;
  int EckY = (fy * FELDSY) + FELDSY / 2 ;

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4; py5 = -py5; py6 = -py6;
      px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4; px5 = -px5; px6 = -px6;
      break;

    default: break;
  } // switch corner

  int X1 = EckX + px1; int Y1 = EckY + py1;
  int X2 = EckX + px2; int Y2 = EckY + py2;
  int X3 = EckX + px3; int Y3 = EckY + py3;
  int X4 = EckX + px4; int Y4 = EckY + py4;
  int X5 = EckX + px5; int Y5 = EckY + py5;
  int X6 = EckX + px6; int Y6 = EckY + py6;

  DrawTrArrow[3] = 6;

  DrawTrArrow[4] = X1 >> 8; DrawTrArrow[5] = X1 & 0x00FF;
  DrawTrArrow[6] = X2 >> 8; DrawTrArrow[7] = X2 & 0x00FF;
  DrawTrArrow[8] = X3 >> 8; DrawTrArrow[9] = X3 & 0x00FF;
  DrawTrArrow[10] = X4 >> 8; DrawTrArrow[11] = X4 & 0x00FF;
  DrawTrArrow[12] = X5 >> 8; DrawTrArrow[13] = X5 & 0x00FF;
  DrawTrArrow[14] = X6 >> 8; DrawTrArrow[15] = X6 & 0x00FF;

  DrawTrArrow[16] = Y1 >> 8; DrawTrArrow[17] = Y1 & 0x00FF;
  DrawTrArrow[18] = Y2 >> 8; DrawTrArrow[19] = Y2 & 0x00FF;
  DrawTrArrow[20] = Y3 >> 8; DrawTrArrow[21] = Y3 & 0x00FF;
  DrawTrArrow[22] = Y4 >> 8; DrawTrArrow[23] = Y4 & 0x00FF;
  DrawTrArrow[24] = Y5 >> 8; DrawTrArrow[25] = Y5 & 0x00FF;
  DrawTrArrow[26] = Y6 >> 8; DrawTrArrow[27] = Y6 & 0x00FF;

  DrawTrArrow[28] = BLACK  >> 8; DrawTrArrow[29] = BLACK  & 0x00FF;
  Serial2.write (DrawTrArrow, 30); delayS2();

  CircleSig(fx, fy, corner, RED);

  StandSig(fx, fy, corner);
} // SigScreen ()



void ShHScreen(int fx, int fy, int corner) {  // Sh-Signal am Hp-Sig

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1 =  4;  int py1 = 7;   //x1 14
  int px2 = 14;  int py2 = 17;  //x2 24

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: px1 = -px1; py1 = -py1;
      px2 = -px2; py2 = -py2;
      break;
    default: break;
  }

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();

  ShHPicture (fx, fy, corner, 0);

  StandHSig(fx, fy, corner);
} // ShHScreen()


void ShScreen(int fx, int fy, int corner) {  // Sh-Signal

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1 = 14;  int py1 = 7;
  int px2 = 24;  int py2 = 17;

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: px1 = -px1; py1 = -py1;
      px2 = -px2; py2 = -py2;
      break;
    default: break;
  }

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();

  ShPicture (fx, fy, corner, 0);

  StandSig(fx, fy, corner);
} // ShScreen()


void ShHPicture (int fx, int fy, int corner, byte ShZeichen) {

  CircleSigShH(fx, fy, corner, WHITE);  // altes Zeichen loeschen

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1, py1, px2, py2;
  int px3, py3, px4, py4;

  switch (ShZeichen) {
    case 0: px1 =  8;  py1 = 7;  // waagerecht, x1 18
      px2 = 10;  py2 = 17; //             x2 20
      break;
    case 1: px1 =  6;  py1 = 9;  // gekippt  , x1 16
      px2 = 13;  py2 = 16; //            x2 23

      px3 =  6;  py3 = 10; // gekippt Linie 2 X3 16
      px4 = 14;  py4 = 17; //                 x4 24
      break;
    default:
      break;
  }

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: px1 = -px1; py1 = -py1;
      px2 = -px2; py2 = -py2;

      px3 = -px3; py3 = -py3;
      px4 = -px4; py4 = -py4;
      break;
    default: break;
  }

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  int X3 = CenterX + px3;  int Y3 = CenterY + py3;
  int X4 = CenterX + px4;  int Y4 = CenterY + py4;

  switch (ShZeichen) {
    case 0: DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
      DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
      DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
      DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
      DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
      Serial2.write (DrawRectaF, 12); delayS2();
      break;
    case 1:
      Linie (X1, Y1, X2, Y2, BLACK);
      Linie (X3, Y3, X4, Y4, BLACK);
      break;
    default: break;
  }

} // ShHPicture()



void ShPicture (int fx, int fy, int corner, byte ShZeichen) {

  CircleSig(fx, fy, corner, WHITE);  // altes Zeichen loeschen

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1, py1, px2, py2;
  int px3, py3, px4, py4;

  switch (ShZeichen) {
    case 0: px1 = 18;  py1 = 7;  // waagerecht
      px2 = 20;  py2 = 17;
      break;
    case 1: px1 = 16;  py1 = 9;  // gekippt
      px2 = 23;  py2 = 16;

      px3 = 16;  py3 = 10; // gekippt Linie 2
      px4 = 23;  py4 = 17;
      break;
    default:
      break;
  }

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: px1 = -px1; py1 = -py1;
      px2 = -px2; py2 = -py2;

      px3 = -px3; py3 = -py3;
      px4 = -px4; py4 = -py4;
      break;
    default: break;
  }

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  int X3 = CenterX + px3;  int Y3 = CenterY + py3;
  int X4 = CenterX + px4;  int Y4 = CenterY + py4;

  switch (ShZeichen) {
    case 0: DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
      DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
      DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
      DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
      DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
      Serial2.write (DrawRectaF, 12); delayS2();
      break;
    case 1:
      Linie (X1, Y1, X2, Y2, BLACK);
      Linie (X3, Y3, X4, Y4, BLACK);
      break;
    default: break;
  }

} // ShPicture()



void StandSig(int fx, int fy, int corner) {  // SignalFuss

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1 = 8;   int py1 = 11;
  int px2 = 13;  int py2 = 13;

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: px1 = -px1; py1 = -py1;
      px2 = -px2; py2 = -py2;
      break;
    default: break;
  }

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // StandSig()


void StandHSig(int fx, int fy, int corner) {  // SignalFuss

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  int px1 = -2;   int py1 = 11;
  int px2 =  3;   int py2 = 13;

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3: px1 = -px1; py1 = -py1;
      px2 = -px2; py2 = -py2;
      break;
    default: break;
  }

  int X1 = CenterX + px1;  int Y1 = CenterY + py1;
  int X2 = CenterX + px2;  int Y2 = CenterY + py2;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // StandHSig()


void TurnoutLong(int fx, int fy, int corner, int colour) {
  //Diagonale Ausleuchtung
  char DrawTrArrow[40] = {0x00, 0x14, 0x00, 0x05, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
  //         Lenght 5  X1        Y1        ...                  Colour

  int EckeX = FELDSX / 2;  int EckeY = FELDSY / 2;

  int px1 = EckeX - 52;  int py1 = EckeY - 32; // -3,-40, Balken auf Linie best -52,-32
  int px2 = EckeX - 15;  int py2 = EckeY -  8; // -3, +0                        -13, -8
  int px3 = EckeX - 13;  int py3 = EckeY - 12; // +3, +0                        -10, -12
  int px4 = EckeX - 50;  int py4 = EckeY - 35; // +3,-40                        -50, -35

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  switch (corner) {
    case 0: break;

    case 1: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4;
      break;

    case 2: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4;
    case 3: px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4;
      break;
    default: break;
  }

  int X1 = CenterX + px1; int Y1 = CenterY + py1;
  int X2 = CenterX + px2; int Y2 = CenterY + py2;
  int X3 = CenterX + px3; int Y3 = CenterY + py3;
  int X4 = CenterX + px4; int Y4 = CenterY + py4;

  DrawTrArrow[3] = 4;

  DrawTrArrow[4] = X1 >> 8; DrawTrArrow[5] = X1 & 0x00FF;
  DrawTrArrow[6] = X2 >> 8; DrawTrArrow[7] = X2 & 0x00FF;
  DrawTrArrow[8] = X3 >> 8; DrawTrArrow[9] = X3 & 0x00FF;
  DrawTrArrow[10] = X4 >> 8; DrawTrArrow[11] = X4 & 0x00FF;

  DrawTrArrow[12] = Y1 >> 8; DrawTrArrow[13] = Y1 & 0x00FF;
  DrawTrArrow[14] = Y2 >> 8; DrawTrArrow[15] = Y2 & 0x00FF;
  DrawTrArrow[16] = Y3 >> 8; DrawTrArrow[17] = Y3 & 0x00FF;
  DrawTrArrow[18] = Y4 >> 8; DrawTrArrow[19] = Y4 & 0x00FF;
  DrawTrArrow[20] = colour  >> 8; DrawTrArrow[21] = colour  & 0x00FF;
  Serial2.write (DrawTrArrow, 22); delayS2();
} // TurnoutLong()



void TurnoutPos(int fx, int fy, int corner, int colour) {
  //Weichenlage abzweigend

  char DrawTrArrow[40] = {0x00, 0x14, 0x00, 0x05, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
  //         Lenght 5  X1        Y1        ...                      Colour

  int EckeX = FELDSX / 2;  int EckeY = FELDSY / 2;

  int px1 = EckeX - 8;  int py1 = EckeY - 3;
  int px2 = EckeX - 6;  int py2 = EckeY - 7;
  int px3 = EckeX - 16; int py3 = EckeY - 12;
  int px4 = EckeX - 18; int py4 = EckeY - 8;

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  switch (corner) {
    case 0: break;

    case 1: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4;
      break;

    case 2: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4;
    case 3: px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4;
      break;
    default: break;
  }

  int X1 = CenterX + px1; int Y1 = CenterY + py1;
  int X2 = CenterX + px2; int Y2 = CenterY + py2;
  int X3 = CenterX + px3; int Y3 = CenterY + py3;
  int X4 = CenterX + px4; int Y4 = CenterY + py4;

  DrawTrArrow[3] = 4;

  DrawTrArrow[4] = X1 >> 8; DrawTrArrow[5] = X1 & 0x00FF;
  DrawTrArrow[6] = X2 >> 8; DrawTrArrow[7] = X2 & 0x00FF;
  DrawTrArrow[8] = X3 >> 8; DrawTrArrow[9] = X3 & 0x00FF;
  DrawTrArrow[10] = X4 >> 8; DrawTrArrow[11] = X4 & 0x00FF;

  DrawTrArrow[12] = Y1 >> 8; DrawTrArrow[13] = Y1 & 0x00FF;
  DrawTrArrow[14] = Y2 >> 8; DrawTrArrow[15] = Y2 & 0x00FF;
  DrawTrArrow[16] = Y3 >> 8; DrawTrArrow[17] = Y3 & 0x00FF;
  DrawTrArrow[18] = Y4 >> 8; DrawTrArrow[19] = Y4 & 0x00FF;
  DrawTrArrow[20] = colour  >> 8; DrawTrArrow[21] = colour  & 0x00FF;
  Serial2.write (DrawTrArrow, 22); delayS2();
} // TurnoutPos()


void TurnoutDir(int fx, int fy, int Turn, int Colour) {
  // Weichenlage Gerade

  int X1 = 0; // top left
  int Y1 = 0;
  int X2 = 0; // bottom right
  int Y2 = 0;

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  switch (Turn) {
    case 0:
    case 1:
      X1 = CenterX + FELDSX / 2 - 18; Y1 = CenterY - TRACK / 2 + 3  ;
      X2 = CenterX + FELDSX / 2 -  6; Y2 = CenterY + TRACK / 2 - 3;
      break;
    case 2:
    case 3:
      X1 = CenterX - FELDSX / 2 + 18; Y1 = CenterY - TRACK / 2 + 3  ;
      X2 = CenterX - FELDSX / 2 +  6; Y2 = CenterY + TRACK / 2 - 3;
      break;
    default:
      break;
  }

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = Colour  >> 8; DrawRectaF[11] = Colour  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // TurnoutDir()




void KreuzWaager(int fx, int fy, int Colour) {
  int X1 = 0; // top left
  int Y1 = 0;
  int X2 = 0; // bottom right
  int Y2 = 0;

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  X1 = CenterX - FELDSX / 2 + 18; Y1 = CenterY - TRACK / 2 + 3; // linke Ausleuchtung
  X2 = CenterX - FELDSX / 2 +  6; Y2 = CenterY + TRACK / 2 - 3;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = Colour  >> 8; DrawRectaF[11] = Colour  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();

  X1 = CenterX + FELDSX / 2 - 18; Y1 = CenterY - TRACK / 2 + 3; // rechte Ausleuchtung
  X2 = CenterX + FELDSX / 2 -  6; Y2 = CenterY + TRACK / 2 - 3;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = Colour  >> 8; DrawRectaF[11] = Colour  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();

} // KreuzWaager()



void DrawDiagonalStand(int fx, int fy, int SwStand) {  // Weiche diagonal

  // 0 unbekannt, 1 Gerade, 2 Bogen
  // Bei 0 beide Grau, bei 1 und 2 alte Lage Grau, neue Lage Weiss

  int w811 = StpM[fy][fx] & 0x000F; // Weiche 8,9,10,11
  byte cor1 = 0;
  byte cor2 = 0;

  switch (w811) {
    case  8: cor1 = 2; cor2 = 2; // ok
      break;
    case  9: if (SwStand == 2) {
        cor1 = 2;
        cor2 = 3;
      }
      else             {
        cor1 = 3;
        cor2 = 2;
      }
      break;
    case 10: cor1 = 0; cor2 = 0; // ok
      break;
    case 11: if (SwStand == 2) {
        cor1 = 0;
        cor2 = 1;
      }
      else             {
        cor1 = 1;
        cor2 = 0;
      }
      break;
    default:
      break;
  } // switch w811

  switch (SwStand) {
    case 0: TurnoutDir(fx, fy, cor2, DGRAY); // cor1
      TurnoutPos(fx, fy, cor1, DGRAY); // cor2
      break;
    case 1: TurnoutPos(fx, fy, cor1, DGRAY); // Lage alt loeschen
      TurnoutDir(fx, fy, cor2, WHITE); // Lage neu gerade
      break;
    case 2: TurnoutDir(fx, fy, cor1, DGRAY); // Lage alt loeschen
      TurnoutPos(fx, fy, cor2, WHITE); // Lage neu bogen
      break;

    default:
      break;
  } // switch()
} // DrawDiagonalStand()


void DrawSwitchStand(int fx, int fy, int SwStand) {  // Weiche horizontal

  // 0 unbekannt, 1 Gerade, 2 Bogen
  // Bei 0 beide Grau, bei 1 und 2 alte Lage Grau, neue Lage Weiss

  int corner = StpM[fy][fx] & 0x0003;

  switch (SwStand) {
    case 0: TurnoutDir(fx, fy, corner, DGRAY);
      TurnoutPos(fx, fy, corner, DGRAY);
      break;
    case 1: TurnoutPos(fx, fy, corner, DGRAY); // Lage alt loeschen
      TurnoutDir(fx, fy, corner, WHITE); // Lage neu gerade
      break;
    case 2: TurnoutDir(fx, fy, corner, DGRAY); // Lage alt loeschen
      TurnoutPos(fx, fy, corner, WHITE); // Lage neu bogen
      break;

    default:
      break;
  } // switch()
} // DrawSwitchStand()


void DrawDWstand(int fx, int fy, int Lage) { // Doppelweiche
  // nur Weiterschaltung, Init mitte,
  // unten, oben, mitte, unten, oben, ...
  uint8_t neuLage = 0;
  uint8_t Ele6bit = StpM[fy][fx] & 0x3F;

  uint16_t  Adr      = 0;
  uint8_t   HAdr     = 0;
  uint8_t   LAdr     = 0;
  bool      ok       = false;

  if (!(Ele6bit & FSTRBEL))  {   // wenn frei, umschalten

    Adr = StpA[fy][fx] & ADRMASK; // 0..2047;
    if (Adr) {
#ifndef LOCONET
      Adr--;    // Versatz !!
#endif
      ok = true;
    }
    else ok = false;

    switch (Ele6bit & 0x1F) {
      case 24: switch (Lage) {                        // Faecher nach links
          case 0:
#ifndef STANZLN
            TurnoutDir(fx, fy, 2, WHITE);  // keine Lage
#endif
            neuLage = 2;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
              Adr++;
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
#else
              requestSwitch(Adr, GRD_GRN, 0);
              requestSwitch(Adr + 1, GRD_GRN, 0);
#endif
            }
            // beide Antriebe gerade       // neu mitte
            break;

          case 1:
#ifndef STANZLN
            TurnoutPos(fx, fy, 2, DGRAY);  // Lage oben
            TurnoutDir(fx, fy, 2, WHITE);  // neu mitte
#endif
            neuLage = 2;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
              Adr++;
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
#else
              requestSwitch(Adr, GRD_GRN, 0);
              requestSwitch(Adr + 1, GRD_GRN, 0);
#endif
            }
            // beide Antriebe gerade
            break;

          case 2:
#ifndef STANZLN
            TurnoutDir(fx, fy, 2, DGRAY);  // Lage mitte
            TurnoutPos(fx, fy, 3, WHITE);  // neu unten
#endif
            neuLage = 3;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
              Adr++;
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1001, 0);
#else
              requestSwitch(Adr, GRD_GRN, 0);
              requestSwitch(Adr + 1, RND_ROT, 0);
#endif
            }
            // 1. Antrieb gerade, 2. Antrieb abzweigend
            break;

          case 3:
#ifndef STANZLN
            TurnoutPos(fx, fy, 3, DGRAY);  // Lage unten
            TurnoutPos(fx, fy, 2, WHITE);  // neu oben
#endif
            neuLage = 1;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1001, 0);
              //Adr++;
              //WR2Queue(highByte(Adr), lowByte(Adr), 0b1001,0);
#else
              requestSwitch(Adr + 1, GRD_GRN, 0);
              requestSwitch(Adr, RND_ROT, 0);
#endif
            }
            // 1. Antrieb abzweigend, 2.Antrieb beliebig
            break;
        }
        StpM[fy][fx] = Ele6bit | (neuLage << 6);
        break;

      case 25: switch (Lage) {                        // Faecher nach rechts
          case 0:
#ifndef STANZLN
            TurnoutDir(fx, fy, 1, WHITE);  // keine Lage
#endif
            neuLage = 2;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
              Adr++;
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
#else
              requestSwitch(Adr, GRD_GRN, 0);
              requestSwitch(Adr + 1, GRD_GRN, 0);
#endif
            }
            // beide Antriebe gerade       // neu mitte
            break;

          case 1:
#ifndef STANZLN
            TurnoutPos(fx, fy, 1, DGRAY);  // Lage oben
            TurnoutDir(fx, fy, 1, WHITE);  // neu miite
#endif
            neuLage = 2;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
              Adr++;
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
#else
              requestSwitch(Adr, GRD_GRN, 0);
              requestSwitch(Adr + 1, GRD_GRN, 0);
#endif
            }
            // beide Antriebe gerade
            break;

          case 2:
#ifndef STANZLN
            TurnoutDir(fx, fy, 1, DGRAY);  // Lage mitte
            TurnoutPos(fx, fy, 0, WHITE);  // neu unten
#endif
            neuLage = 3;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1001, 0);
              //Adr++;
              //WR2Queue(highByte(Adr), lowByte(Adr), 0b1000,0);
#else
              requestSwitch(Adr + 1, GRD_GRN, 0);
              requestSwitch(Adr, RND_ROT, 0);
#endif
            }
            // 1. Antrieb abzweigend, 2. Antrieb beliebig
            break;

          case 3:
#ifndef STANZLN
            TurnoutPos(fx, fy, 0, DGRAY);  // Lage unten
            TurnoutPos(fx, fy, 1, WHITE);  // neu oben
#endif
            neuLage = 1;
            if (ok) {
#ifndef LOCONET
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1000, 0);
              Adr++;
              WR2Queue(highByte(Adr), lowByte(Adr), 0b1001, 0);
#else
              requestSwitch(Adr, GRD_GRN, 0);
              requestSwitch(Adr + 1, RND_ROT, 0);
#endif
            }
            // 1. Antrieb gerade, 2. Antrieb abzweigend
            break;
        }
        StpM[fy][fx] = Ele6bit | (neuLage << 6);
        break;

      default:
        break;
    } // switch Ele
  }  // if not Fstr.
#ifndef LOCONET
  AnzeigeEle(1, Ele6bit);
#endif
} // DrawDWstand()


void ShowEraseLageDW(int fx, int fy, uint16_t color) {

  uint8_t  ElementLage = StpM[fy][fx];
  uint8_t  Lage        = ElementLage >> 6;
  uint8_t  Element     = ElementLage & 0x1F;

  if (Element == 24) {
    switch (Lage) {
      case 1: TurnoutPos(fx, fy, 2, color); break; // oben
      case 2: TurnoutDir(fx, fy, 2, color); break; // mitte
      case 3: TurnoutPos(fx, fy, 3, color); break; // unten
      default: break;
    }
  } // if Element
  else {  // Element 25
    switch (Lage) {
      case 1: TurnoutPos(fx, fy, 1, color); break; // oben
      case 2: TurnoutDir(fx, fy, 1, color); break; // mitte
      case 3: TurnoutPos(fx, fy, 0, color); break; // unten
      default: break;
    }
  }
} // ShowEraseLageDW()


void TrackArrow (int fx, int fy, int corner) {
  // von den Ecken zur Mitte
  /*
    -x, -y     |     x, -y
    -----------0------------
    -x,  y     |     x,  y
  */
  char DrawTrArrow[40] = {0x00, 0x14, 0x00, 0x05, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
  //         Lenght 5  X1        Y1        ...                      Colour

  int px1 = FELDSX / 2;  int py1 = FELDSY / 2;
  int px2 = px1;       int py2 = py1 - 7;
  int px3 =  12;       int py3 = TRACK / 2;
  int px4 = -10;       int py4 = py3;
  int px5 = px1 - 7;   int py5 = py1;

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  switch (corner) {
    case 0: break;

    case 1: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4; py5 = -py5;
      break;

    case 2: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4; py5 = -py5;
    case 3: px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4; px5 = -px5;
      break;
    default: break;
  }

  int X1 = CenterX + px1; int Y1 = CenterY + py1;
  int X2 = CenterX + px2; int Y2 = CenterY + py2;
  int X3 = CenterX + px3; int Y3 = CenterY + py3;
  int X4 = CenterX + px4; int Y4 = CenterY + py4;
  int X5 = CenterX + px5; int Y5 = CenterY + py5;

  DrawTrArrow[3] = 5;

  DrawTrArrow[4] = X1 >> 8; DrawTrArrow[5] = X1 & 0x00FF;
  DrawTrArrow[6] = X2 >> 8; DrawTrArrow[7] = X2 & 0x00FF;
  DrawTrArrow[8] = X3 >> 8; DrawTrArrow[9] = X3 & 0x00FF;
  DrawTrArrow[10] = X4 >> 8; DrawTrArrow[11] = X4 & 0x00FF;
  DrawTrArrow[12] = X5 >> 8; DrawTrArrow[13] = X5 & 0x00FF;
  DrawTrArrow[14] = Y1 >> 8; DrawTrArrow[15] = Y1 & 0x00FF;
  DrawTrArrow[16] = Y2 >> 8; DrawTrArrow[17] = Y2 & 0x00FF;
  DrawTrArrow[18] = Y3 >> 8; DrawTrArrow[19] = Y3 & 0x00FF;
  DrawTrArrow[20] = Y4 >> 8; DrawTrArrow[21] = Y4 & 0x00FF;
  DrawTrArrow[22] = Y5 >> 8; DrawTrArrow[23] = Y5 & 0x00FF;
  DrawTrArrow[24] = BLACK  >> 8; DrawTrArrow[25] = BLACK  & 0x00FF;
  Serial2.write (DrawTrArrow, 26); delayS2();
} // TrackArrow ()


void DrawTurnout(int fx, int fy, int corner) { //Zeichnet Gerade und Bogen
  TrackLine (fx, fy);
  TrackArrow(fx, fy, corner);
  DrawSwitchStand(fx, fy, 0); // Lage unbekannt
} // DrawTurnout()



void DrawSTurnout(int fx, int fy, int corner) { //Zeichnet Diagonale und Gerade
  TrackSlant(fx, fy, corner);
  TrackHLine(fx, fy, corner);
  DrawDiagonalStand(fx, fy, 0); // Lage unbekannt
} // DrawSTurnout()


void TrackEnviron (int fx, int fy) { // RC-Number Feld clear
  // X1, Y1 top left
  // X2, Y2 bottom right

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);
  int X1 = CenterX - FELDSX / 2; int Y1 = CenterY - (TRACK / 2 + 1) ;
  int X2 = CenterX + FELDSX / 2; int Y2 = CenterY + (TRACK / 2 + 2) ;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = OFFGRAY  >> 8; DrawRectaF[11] = OFFGRAY  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // TrackEnviron()


void TrackLine (int fx, int fy) {

  // X1, Y1 top left
  // X2, Y2 bottom right

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);
  int X1 = CenterX - FELDSX / 2; int Y1 = CenterY - TRACK / 2 ;
  int X2 = CenterX + FELDSX / 2; int Y2 = CenterY + TRACK / 2 ;

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // TrackLine()


void TrackHLine (int fx, int fy, int corner) {  // Turnout Line

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);
  int X1 = CenterX - FELDSX / 2; int Y1 = CenterY - TRACK / 2 ;
  int X2 = CenterX ;            int Y2 = CenterY + TRACK / 2 ;

  switch (corner) {
    case 0:
    case 1:
      break;
    case 2:
    case 3: X1 = CenterX ; X2 = CenterX + FELDSX / 2;
      break;

    default: break;
  } // switch corner

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = BLACK  >> 8; DrawRectaF[11] = BLACK  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // TrackHLine()



void TrackSlant (int fx, int fy, int corner) { // Diagonale
  char DrawTrArrow[40] = {0x00, 0x14, 0x00, 0x05, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
  //         Lenght 5  X1        Y1        ...                      Colour

  int px1 = FELDSX;    int py1 = FELDSY;
  int px2 = FELDSX;    int py2 = FELDSY - 7;
  int px3 = 7;         int py3 = 0;
  int px4 = 0;         int py4 = 0;
  int px5 = 0;         int py5 = 7;
  int px6 = FELDSX - 7; int py6 = FELDSY;

  int EckX = fx * FELDSX ;
  int EckY = fy * FELDSY ;

  switch (corner) {
    case 0:
    case 2:
      break;
    case 1:
    case 3:
      px1 = 0;               px2 = 7;          py2 = FELDSY; px3 = FELDSX; py3 = 7;
      px4 = FELDSX; py4 = 0; px5 = FELDSX - 7; py5 = 0;      px6 = 0;      py6 = FELDSY - 7;
      break;

    default: break;
  } // switch corner

  int X1 = EckX + px1; int Y1 = EckY + py1;
  int X2 = EckX + px2; int Y2 = EckY + py2;
  int X3 = EckX + px3; int Y3 = EckY + py3;
  int X4 = EckX + px4; int Y4 = EckY + py4;
  int X5 = EckX + px5; int Y5 = EckY + py5;
  int X6 = EckX + px6; int Y6 = EckY + py6;

  DrawTrArrow[3] = 6;

  DrawTrArrow[4] = X1 >> 8; DrawTrArrow[5] = X1 & 0x00FF;
  DrawTrArrow[6] = X2 >> 8; DrawTrArrow[7] = X2 & 0x00FF;
  DrawTrArrow[8] = X3 >> 8; DrawTrArrow[9] = X3 & 0x00FF;
  DrawTrArrow[10] = X4 >> 8; DrawTrArrow[11] = X4 & 0x00FF;
  DrawTrArrow[12] = X5 >> 8; DrawTrArrow[13] = X5 & 0x00FF;
  DrawTrArrow[14] = X6 >> 8; DrawTrArrow[15] = X6 & 0x00FF;

  DrawTrArrow[16] = Y1 >> 8; DrawTrArrow[17] = Y1 & 0x00FF;
  DrawTrArrow[18] = Y2 >> 8; DrawTrArrow[19] = Y2 & 0x00FF;
  DrawTrArrow[20] = Y3 >> 8; DrawTrArrow[21] = Y3 & 0x00FF;
  DrawTrArrow[22] = Y4 >> 8; DrawTrArrow[23] = Y4 & 0x00FF;
  DrawTrArrow[24] = Y5 >> 8; DrawTrArrow[25] = Y5 & 0x00FF;
  DrawTrArrow[26] = Y6 >> 8; DrawTrArrow[27] = Y6 & 0x00FF;

  DrawTrArrow[28] = BLACK  >> 8; DrawTrArrow[29] = BLACK  & 0x00FF;
  Serial2.write (DrawTrArrow, 30); delayS2();
} // TrackSlant ()



void TrackEdge(int fx, int fy, byte Edge) {
  // Bahnsteigkante (platform edge)
  int Y1 = 0; int Y2 = 0;
  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);
  int X1 = CenterX - FELDSX / 2;
  int X2 = CenterX + FELDSX / 2;

  if (Edge) {
    Y1 = CenterY + 16;
    Y2 = CenterY +  8;
  }
  else      {
    Y1 = CenterY - 16;
    Y2 = CenterY -  8;
  }

  DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
  DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
  DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
  DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
  DrawRectaF[10] = SILGRAY  >> 8; DrawRectaF[11] = SILGRAY  & 0x00FF;
  Serial2.write (DrawRectaF, 12); delayS2();
} // TrackEdge()


void TrackLight (int fx, int fy, int Colour) {
  // Ausleuchtung
  if (fx + fy) { // avoid light in 0,0 (unused RMpins)
    // X1, Y1 top left
    // X2, Y2 bottom right

    int CenterX = fx * FELDSX + (FELDSX / 2);
    int CenterY = fy * FELDSY + (FELDSY / 2);
    int X1 = CenterX - FELDSX / 2 + 7; int Y1 = CenterY - TRACK / 2 + 3;
    int X2 = CenterX + FELDSX / 2 - 7; int Y2 = CenterY + TRACK / 2 - 3;

    if (StpM[fy][fx] & DETECTSET) Colour = RED;
    DrawRectaF[2] = X1 >> 8; DrawRectaF[3] = X1 & 0x00FF;
    DrawRectaF[4] = Y1 >> 8; DrawRectaF[5] = Y1 & 0x00FF;
    DrawRectaF[6] = X2 >> 8; DrawRectaF[7] = X2 & 0x00FF;
    DrawRectaF[8] = Y2 >> 8; DrawRectaF[9] = Y2 & 0x00FF;
    DrawRectaF[10] = Colour  >> 8; DrawRectaF[11] = Colour  & 0x00FF;
    Serial2.write (DrawRectaF, 12); delayS2();

  } // if
} // TrackLight()


void DrawPoly4 (int fx, int fy, int corner) {
  char DataPoly4[40]  = {0x00, 0x14, 0x00, 0x04, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
  //         Lenght 4  X1        Y1        ...                      Colour

  int px1 = 12;        int py1 =  TRACK / 2;
  int px2 = -7;        int py2 = (-TRACK / 2) - 1;
  int px3 = -FELDSX / 2; int py3 = py2;
  int px4 = -FELDSX / 2; int py4 = py1;

  int CenterX = fx * FELDSX + (FELDSX / 2);
  int CenterY = fy * FELDSY + (FELDSY / 2);

  switch (corner) {
    case 0: break;

    case 1: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4;
      break;

    case 2: py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4;
    case 3: px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4;
      break;
    default: break;
  } // switch corner

  int X1 = CenterX + px1; int Y1 = CenterY + py1;
  int X2 = CenterX + px2; int Y2 = CenterY + py2;
  int X3 = CenterX + px3; int Y3 = CenterY + py3;
  int X4 = CenterX + px4; int Y4 = CenterY + py4;

  DataPoly4[4] = X1 >> 8; DataPoly4[5] = X1 & 0x00FF;
  DataPoly4[6] = X2 >> 8; DataPoly4[7] = X2 & 0x00FF;
  DataPoly4[8] = X3 >> 8; DataPoly4[9] = X3 & 0x00FF;
  DataPoly4[10] = X4 >> 8; DataPoly4[11] = X4 & 0x00FF;

  DataPoly4[12] = Y1 >> 8; DataPoly4[13] = Y1 & 0x00FF;
  DataPoly4[14] = Y2 >> 8; DataPoly4[15] = Y2 & 0x00FF;
  DataPoly4[16] = Y3 >> 8; DataPoly4[17] = Y3 & 0x00FF;
  DataPoly4[18] = Y4 >> 8; DataPoly4[19] = Y4 & 0x00FF;

  DataPoly4[20] = BLACK  >> 8; DataPoly4[21] = BLACK  & 0x00FF;
  Serial2.write (DataPoly4, 22); delayS2();
} // DrawPoly4 ()


void PosLight(int fx, int fy, int colour) {

  int corner = StpM[fy][fx] & 0x0003;
  TurnoutPos(fx, fy, corner, colour);
} // PosLight()


void ElementDraw(int x, int y, byte Element) { // Aufruf beim Gleisbild-Aufbau (csvParser.cpp)
  //Serial.print(" E:"); Serial.print(Element);
  switch (Element) {
    case 1: TrackLine(x, y);
      TrackLight(x, y, DGRAY);
      break;
    case 2: TrackLine(x, y);
      TrackLight(x, y, DGRAY);
      TrackEdge(x, y, 0);  // Bahnsteig Kante oben
      break;
    case 3: TrackLine(x, y);
      TrackLight(x, y, DGRAY);
      TrackEdge(x, y, 1); // Bahnsteig Kante unten
      break;
    case 4:                        // Ecke
    case 5:
    case 6:
    case 7:
      DrawPoly4 (x, y, Element & 0x03);
      TrackArrow(x, y, Element & 0x03);
      PosLight  (x, y, DGRAY);
      break;
    case  8:                       // Weichen /-
    case  9:
    case 10:
    case 11: DrawSTurnout(x, y, Element & 0x03);
      break;

    case 16:                       // Weichen _/_
    case 17:
    case 18:
    case 19: DrawTurnout(x, y, Element & 0x03);
      break;

    case 20:                       // Diagonale Backslash ... !
    case 21: TrackSlant(x, y, Element & 0x03);
      TurnoutLong(x, y, Element & 0x03, DGRAY);
      break;

    case 22: TrackSlant(x, y, Element & 0x03);           // Kreuzung
      TrackLine (x, y);
      TurnoutDir(x, y, 2, DGRAY);
      TurnoutPos(x, y, 2, DGRAY);
      TurnoutDir(x, y, 0, DGRAY);
      TurnoutPos(x, y, 0, DGRAY);
      break;
    case 23: TrackSlant(x, y, Element & 0x03);
      TrackLine (x, y);
      TurnoutDir(x, y, 3, DGRAY);
      TurnoutPos(x, y, 3, DGRAY);
      TurnoutDir(x, y, 1, DGRAY);
      TurnoutPos(x, y, 1, DGRAY);
      break;
    case 24: TrackLine (x, y);                    // Doppelweiche links Faecher
      TrackArrow(x, y, 2);                 // \_
      TrackArrow(x, y, 3);                 // /
      TurnoutDir(x, y, 2, DGRAY);          // -. links
      TurnoutPos(x, y, 2, DGRAY);          // \
      //TurnoutPos(x, y, 3, DGRAY);          // /
      //delay(1);
      TurnoutPos(x, y, 3, DGRAY);

      break;
    case 25: TrackLine (x, y);                    // Doppelweiche rechts Faecher
      TrackArrow(x, y, 1);                 // _/
      TrackArrow(x, y, 0);                 //  \ 
      //TurnoutDir(x, y, 1, DGRAY);          // .- rechts
      //delay(1);
      TurnoutDir(x, y, 1, DGRAY);
      TurnoutPos(x, y, 0, DGRAY);
      TurnoutPos(x, y, 1, DGRAY);
      break;

    case 28:                       // Hauptsignal
    case 29: SigScreen(x, y, Element & 0x03);
      break;
    default:
      break;
  } // switch ()
} // ElementDraw()


void TextKoord(void) { // Nummerung der Stelltischfelder
  int y1 = FELDSY / 2 + 7;
  int x1 = 0;

  Serial2.write(TextBackGrnd, 4);
  Serial2.write(TextColourBl, 4);
  TextFont[3] = 5; Serial2.write(TextFont, 4);

  for (int x = 0; x < GL_xmax; x++) {
    if (StpM[0][x] == 0) {
      x1 =  (x * FELDSX) + FELDSX / 2 - 4;
      TextOrigin[2] = x1 >> 8; TextOrigin[3] =  x1 & 0x00FF;
      TextOrigin[4] = y1 >> 8; TextOrigin[5] =  y1 & 0x00FF;
      Serial2.write(TextOrigin, 6); delayS2();

      bingo[0] = (x & 0x00FF) | 0x30;
      Serial2.write (0x00);    Serial2.write (0x18);
      Serial2.write (bingo, 1); Serial2.write (0); delayS2();
    }
  } // for x

  x1 = FELDSX / 2 - 4;
  for (int y = 1; y < GL_ymax; y++) {
    if (StpM[y][0] == 0) {
      y1 =  (y * FELDSY) + (FELDSY / 2) + 7;
      TextOrigin[2] = x1 >> 8; TextOrigin[3] =  x1 & 0x00FF;
      TextOrigin[4] = y1 >> 8; TextOrigin[5] =  y1 & 0x00FF;
      Serial2.write(TextOrigin, 6); delayS2();

      bingo[0] = (y & 0x00FF) | 0x30;
      Serial2.write (0x00);    Serial2.write (0x18);
      Serial2.write (bingo, 1); Serial2.write (0); delayS2();
    }
  } // for y
} // TextKoord()


void Linie(int x1, int y1, int x2, int y2, int linecol) {
  char DrawLine[]     = {0xFF, 0x7D, 0x00, 0x00, 0x00, 0x80, 0x00, 0xFF, 0x00, 0x80, 0x84, 0x10};
  //         X1        Y1        X2        Y2        Colour

  DrawLine[2] = x1 >> 8; DrawLine[3] =  x1 & 0x00FF;
  DrawLine[4] = y1 >> 8; DrawLine[5] =  y1 & 0x00FF;
  DrawLine[6] = x2 >> 8; DrawLine[7] =  x2 & 0x00FF;
  DrawLine[8] = y2 >> 8; DrawLine[9] =  y2 & 0x00FF;
  DrawLine[10] = linecol >> 8; DrawLine[11] = linecol & 0x00FF;
  Serial2.write (DrawLine, 12); delayS2();
} // Linie()


void DisplayLogo(int fx, int fy) {

  FeldFarbe2 (fx, fy, 0xFF80); // Gelb wie DiMo

#define BMPOFFS 10  // pos. im Header
#define PICWITH 18
#define PICHIGT 22

  int EckeX = fx * FELDSX + 6;  int EckeY = fy * FELDSY;

  int BMPx  = pgm_read_byte_near(bmppic + PICWITH);
  int BMPy  = pgm_read_byte_near(bmppic + PICHIGT);

  int BMPptr = bmppic + pgm_read_byte_near(bmppic + BMPOFFS); // Start der Bilddaten
  byte colorH = 0;
  byte colorL = 0;

  int pixXptr = 0;
  int pixYptr = 0;

  EckeY = EckeY + FELDSY - 2; // von unten nach oben

  for (int ypos = 0; ypos < (BMPy - 2); ypos++) {
    pixYptr = EckeY - ypos;
    SetPixel[4] = pixYptr >> 8; SetPixel[5] = pixYptr & 0x00FF;
    for (int xpos = 0; xpos < BMPx; xpos++) {
      if ((xpos > 7) && (xpos < 45)) {
        pixXptr = EckeX + xpos;
        SetPixel[2] = pixXptr >> 8; SetPixel[3] = pixXptr & 0x00FF;
        colorL = pgm_read_byte_near(BMPptr++);
        colorH = pgm_read_byte_near(BMPptr++);
        SetPixel[6] = colorH; SetPixel[7] = colorL;
        Serial2.write (SetPixel, 8); delayS2();
      } // if
      else BMPptr = BMPptr + 2;
    } // for x
  } // for y

} // DisplayLogo()
