#include <Arduino.h>
#include <EEPROM.h>

#ifndef _csv_str_h
#define _csv_str_h
#include "csv_str.h"
#endif

#define  hdDIM      16
#define  EEPPV      2 * hdDIM
#define  HDSTRPVLEN 3 * hdDIM  // Blocksize Header EEPROM
#define  EEPpos     6 * hdDIM  // ab V.37 neuer Start, Gap 48 Byte tbd
#define  XAHDSTRPV  EEPPV + 9  // PV9
#define  RCLeep     EEPPV + 8  // Route Class
#define  LogoSize   EEPPV + 7  // DiMo Logo an 0,0
#define  DEBUGOPT   EEPPV + 6  // Debug-Ausgaben, Bit-kodiert

#ifdef LOCONET
#define SALoconet  EEPPV + 9   // Stellungsmeldung über LocoNet
#define RMOffset1  EEPPV + 4   // 1. Rückmelder-Offset für LocoNet-Betriebsart
#define RMOffset2  EEPPV + 2   // 2. Rückmelder-Offset für LocoNet-Betriebsart
#define RMStStat   EEPPV + 1   // Rueckmelder-Startstatus
#define RMLoconet  EEPPV + 0   // Rückmelder über LocoNet-Nachrichten

#define RMAdrMax    2048       // Maximale Rueckmelder-Adresse im LocoNet
#define RMAdrSiz    8          // Anzahl der Rueckmelder pro Offset
#define RMOffMax    (RMAdrMax - RMAdrSiz)
//                                Maximaler Rueckmelder-Offset
#define BaudRate0   9600       // Baudrate für Kommunikation über USB
#define BaudRate2   9600       // Baudrate für Kommunikation zum Display
#define BaudIndex   0x06       // 0x06=9600 0x07=14000 0x08=19200 0x09=31250 0x0A=38400 0x0B=56000 0x0C=57600 0x0D=115200
//                                Index für Baudraten-Einstellung zum Display
#endif

void csvNew(void);             // Aufruf von csvNew()DURCH xx.ino

extern uint8_t EEPcheck(void); // Aufruf EEPcheck() IN xx.ino

// EEP Header im RAM
typedef struct {            // Struktur Header
  uint16_t res1;
  uint16_t offsetinfo;
  uint16_t offsetHeader;
  uint32_t wrcycle;
  uint16_t EEid;
  uint16_t LocoLast;
  uint16_t LocoQuant;
} EEP_t_hd;   // 16 Bytes

union {
  EEP_t_hd hd;
  uint8_t bheader[hdDIM];
} hdt, hdb;
